## digikam 3.5.0

=== core/CMakeLists.txt ===

PROJECT(digikam)

MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS "Starting CMake configuration for: digiKam")

OPTION(ENABLE_SCRIPTIFACE      "Build digiKam with experimental scripting support (default=OFF)"       OFF)
OPTION(ENABLE_PRESENTATIONMODE "Build digiKam with presentation mode support (default=OFF)"            OFF)
OPTION(ENABLE_THUMBS_DB        "Build digiKam with thumbnails database support (default=ON)"           ON)
OPTION(ENABLE_INTERNALMYSQL    "Look for MySQL server executable at build time (default=ON)"           ON)
OPTION(ENABLE_ADVANCEDDEBUGMSG "Build digiKam with more internal debug message (default=OFF)"          OFF)
#OPTION(ENABLE_NEPOMUKSUPPORT   "Build digiKam with Nepomuk support (default=OFF)"                      OFF)
OPTION(ENABLE_LCMS2            "Link digiKam to LCMS2 instead LCMS1 (experimental) (default=OFF)"      OFF)

# NOTE: since 6.11.24, libpgf do not support very well OpenMP. We disable it temporally.
# See B.K.O #273765 for details.
OPTION(ENABLE_PGF_OPENMP       "Build digiKam with paralelized PGF codec (experimental) (default=OFF)" OFF)
OPTION(DIGIKAM_ENABLE_MODELTEST "Enable ModelTest on some models for debugging (default=OFF)"          OFF)

# ==================================================================================================
# Information to update before to release this package.

# digiKam version
SET(DIGIKAM_MAJOR_VERSION "3")
SET(DIGIKAM_MINOR_VERSION "5")
SET(DIGIKAM_PATCH_VERSION "0")

#digiKam release date
SET(DIGIKAM_RELEASE_DATE "2013-XX-XX")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
SET(DIGIKAM_SUFFIX_VERSION "")

# ==================================================================================================
# Set env. variables accordingly.

SET(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
   )

SET(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
   )

# Path to find Extra CMake scripts
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# ==================================================================================================
# Debug area codes
# These codes will be set for every project specific path automatically, so
# that you can use kDebug() without any usage of the area code throughout the
# digiKam code base.
SET(AREA_CODE_GENERAL        "50003")
SET(AREA_CODE_KIOSLAVES      "50004")
SET(AREA_CODE_SHOWFOTO       "50005")
SET(AREA_CODE_IMAGEPLUGINS   "50006")
SET(AREA_CODE_DATABASESERVER "50007")
ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${AREA_CODE_GENERAL})
ADD_DEFINITIONS(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)

MACRO(SET_DEBUG_AREA_CODE _areacode)
    REMOVE_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${AREA_CODE_GENERAL})
    ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${_areacode})
ENDMACRO(SET_DEBUG_AREA_CODE)

# =======================================================
# some useful macros for printing status information

SET(PRINT_COMPILE_LENGTH "40")
MACRO(FILL_WITH_DOTS VAR)

    STRING(LENGTH ${${VAR}} NAME_LENGTH)

    MATH(EXPR DOT_LENGTH "${PRINT_COMPILE_LENGTH} - ${NAME_LENGTH}")
    IF(${DOT_LENGTH} LESS 0)
        SET(DOT_LENGTH 0)
    ENDIF(${DOT_LENGTH} LESS 0)

    FOREACH(COUNT RANGE ${DOT_LENGTH})
        SET(${VAR} "${${VAR}}.")
    ENDFOREACH(COUNT)

ENDMACRO(FILL_WITH_DOTS)

MACRO(PRINT_LIBRARY_STATUS NAME WEBSITE VERSIONHINT)

    SET(LIB_MESSAGE "${NAME} library found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(SEND_ERROR " digiKam needs ${NAME}. You need to install the ${NAME}${VERSIONHINT} library development package.")
        MESSAGE(STATUS " ${NAME} website is at ${WEBSITE}")
        MESSAGE(STATUS "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_LIBRARY_STATUS)

MACRO(PRINT_QTMODULE_STATUS NAME)

    SET(LIB_MESSAGE "${NAME} module found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(SEND_ERROR " digiKam needs ${NAME} module. You need to install a package containing the ${NAME} module.")
        MESSAGE(STATUS "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_QTMODULE_STATUS)

MACRO(PRINT_EXECUTABLE_STATUS NAME TECHNICAL_NAME PATH_VARIABLE)

    SET(LIB_MESSAGE "${NAME} found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(STATUS " digiKam needs ${NAME}. You need to install the package containing the \"${TECHNICAL_NAME}\" executable.")
        MESSAGE(STATUS " If you have this executable installed, please specify the folder containing it by ${PATH_VARIABLE}")
        MESSAGE(SEND_ERROR "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_EXECUTABLE_STATUS)

# ==================================================================================================
# Dependencies

FIND_PACKAGE(KDE4 REQUIRED)
INCLUDE(KDE4Defaults)
INCLUDE(MacroLibrary)

INCLUDE(FindPackageHandleStandardArgs)
INCLUDE(FindPkgConfig)
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} )

FIND_PACKAGE(Kipi 2.0.0 REQUIRED)
FIND_PACKAGE(Kexiv2     REQUIRED)
FIND_PACKAGE(Kdcraw     REQUIRED)
FIND_PACKAGE(JPEG       REQUIRED)
FIND_PACKAGE(PNG        REQUIRED)
FIND_PACKAGE(TIFF       REQUIRED)

FIND_PACKAGE(PkgConfig)
FIND_PACKAGE(Jasper)
FIND_PACKAGE(Kface)
FIND_PACKAGE(KGeoMap)
FIND_PACKAGE(PGF)
FIND_PACKAGE(Eigen3)
FIND_PACKAGE(Boost) # 1.36.0)

# BEGIN SPECIAL OPENCV HANDLING

# On some systems, OpenCV can be found using FIND_PACKAGE(OpenCV), for other systems
# we ship our own version of FindOpenCV.cmake. But that does not work on all systems.
# Therefore, first try finding OpenCV using FIND_PACKAGE(OpenCV), and if that fails,
# add our FindOpenCV.cmake to the search path and search again.

MESSAGE(STATUS "First try at finding OpenCV...")
FIND_PACKAGE(OpenCV)

IF (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)
  MESSAGE(STATUS "Could not find OpenCV normally, trying internal FindOpenCV.cmake")
   SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/modules_opencv)
  FIND_PACKAGE(OpenCV REQUIRED)
ELSE (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)
  MESSAGE(STATUS "Great, found OpenCV on the first try.")
ENDIF (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)

MESSAGE(STATUS "OpenCV Root directory is ${OpenCV_DIR}")

# there are two versions of FindOpenCV.cmake in the wild, one defining
# OpenCV_LIBRARIES, the other defining OpenCV_LIBS. Make sure we handle
# both cases.
IF (NOT OpenCV_LIBRARIES)
  SET(OpenCV_LIBRARIES ${OpenCV_LIBS})
ENDIF (NOT OpenCV_LIBRARIES)

# same story with OpenCV_INCLUDE_DIRS and OpenCV_INCLUDE_DIR:
IF (NOT OpenCV_INCLUDE_DIRS)
  SET(OpenCV_INCLUDE_DIRS ${OpenCV_INCLUDE_DIR})
ENDIF (NOT OpenCV_INCLUDE_DIRS)

# END SPECIAL OPENCV HANDLING

# check the libkdcraw version

SET(KDCRAW_MIN_VERSION "2.2.0")

IF (KDCRAW_VERSION)

    MESSAGE(STATUS "libkdcraw: Found version ${KDCRAW_VERSION} (required: ${KDCRAW_MIN_VERSION})")
    IF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})
        SET(KDCRAW_FOUND FALSE)
    ENDIF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})

ELSE (KDCRAW_VERSION)

    MESSAGE(WARNING "libkdcraw: Version information not found, your version is probably too old.")
    SET(KDCRAW_FOUND FALSE)

ENDIF (KDCRAW_VERSION)

# LCMS version 1 and 2 library handling
# See B.K.O #294105
# At the moment (2.6) we still DEFAULT to LCMS1 because porting to LCMS2 still experimental.
# It's possible to force to use LCMS2 by switch on ENABLE_LCMS2 option
# Future plans:
#   2.7 will compile against lcms2 by default but lcms1 will stay as a fallback
#   2.8 will support lcms2 only, probably ENABLE_LCMS2 will be removed too
#       unless we decide to support another color management library
# Note: if ENABLE_LCMS2 is on and no LCMS2 is available, build will fail, even if LCMS1 is present
IF (ENABLE_LCMS2)
    MESSAGE(STATUS "Check for LCMS2 availability...")
    FIND_PACKAGE(LCMS2)
    IF (LCMS2_FOUND AND (LCMS2_VERSION VERSION_EQUAL 2.1 OR LCMS2_VERSION VERSION_GREATER 2.1))
        MESSAGE(STATUS "Found LCMS2: ${LCMS2_LIBRARIES} ${LCMS2_INCLUDE_DIR}")
        SET(LCMS_FOUND ${LCMS2_FOUND})
        SET(LCMS_LIBRARIES ${LCMS2_LIBRARIES})
        SET(LCMS_INCLUDE_DIR ${LCMS2_INCLUDE_DIR})
        SET(USE_LCMS_VERSION_2000 1)
    ENDIF (LCMS2_FOUND AND (LCMS2_VERSION VERSION_EQUAL 2.1 OR LCMS2_VERSION VERSION_GREATER 2.1))
ELSE (ENABLE_LCMS2)
    MESSAGE(STATUS "Check for LCMS1 availability...")
    FIND_PACKAGE(LCMS)
    IF (LCMS_FOUND)
        MESSAGE(STATUS "Found LCMS1: ${LCMS_LIBRARIES} ${LCMS_INCLUDE_DIR}")
        SET(USE_LCMS_VERSION_1000 1)
    ELSE (LCMS_FOUND)
        MESSAGE(STATUS "Check for LCMS2 availability instead LCMS1...")
        FIND_PACKAGE(LCMS2)
        IF (LCMS2_FOUND AND (LCMS2_VERSION VERSION_EQUAL 2.1 OR LCMS2_VERSION VERSION_GREATER 2.1))
            MESSAGE(STATUS "Found LCMS2 instead LCMS1: ${LCMS2_LIBRARIES} ${LCMS2_INCLUDE_DIR}")
            MESSAGE(WARNING "Support of LCMS2 still experimental")
            MESSAGE(WARNING "Please install LCMS1 if possible")
            SET(LCMS_FOUND ${LCMS2_FOUND})
            SET(LCMS_LIBRARIES ${LCMS2_LIBRARIES})
            SET(LCMS_INCLUDE_DIR ${LCMS2_INCLUDE_DIR})
            SET(USE_LCMS_VERSION_2000 1)
        ENDIF (LCMS2_FOUND AND (LCMS2_VERSION VERSION_EQUAL 2.1 OR LCMS2_VERSION VERSION_GREATER 2.1))
    ENDIF (LCMS_FOUND)
ENDIF (ENABLE_LCMS2)

# To link under Solaris (see B.K.O #274484)
IF(NOT WIN32)
    FIND_LIBRARY(MATH_LIBRARY m)
ENDIF(NOT WIN32)

IF(Boost_FOUND)
    INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF(Boost_FOUND)

#-------------------------------------------------------------------------------------

MACRO_BOOL_TO_01(PGF_FOUND USE_EXT_LIBPGF)

# NOTE: currently libpgf 6.11.24 do not support very well OpenMP. We disable it temporally.
# See B.K.O #273765 for details.
IF(NOT ENABLE_PGF_OPENMP)
    ADD_DEFINITIONS(-DLIBPGF_DISABLE_OPENMP)
    MESSAGE(STATUS "Paralelized PGF codec disabled...")
ELSE(NOT ENABLE_PGF_OPENMP)
    MESSAGE(STATUS "Paralelized PGF codec enabled...")
ENDIF(NOT ENABLE_PGF_OPENMP)

# LibPGF need to be linked to OpenMP if necessary.
# OpenMP detection (requires CMake >= 2.6.3)
# NOTE: OpenMP under MacOSX do not support multithreading.

IF(NOT APPLE AND NOT USE_EXT_LIBPGF)
    MACRO_OPTIONAL_FIND_PACKAGE(OpenMP)

    IF(OPENMP_FOUND)
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

        # OpenMP definitions ${OpenMP_CXX_FLAGS} is set on right digiKam components through sub-cmake scripts.
        IF("${OpenMP_CXX_FLAGS}" STREQUAL "-fopenmp" )
            SET(OPENMP_LDFLAGS "-lgomp")
        ENDIF("${OpenMP_CXX_FLAGS}" STREQUAL "-fopenmp" )
        IF("${OpenMP_CXX_FLAGS}" STREQUAL "-xopenmp" )
            SET(OPENMP_LDFLAGS "-xopenmp")
        ENDIF("${OpenMP_CXX_FLAGS}" STREQUAL "-xopenmp" )
    ENDIF(OPENMP_FOUND)
ENDIF(NOT APPLE AND NOT USE_EXT_LIBPGF)

#-------------------------------------------------------------------------------------

IF(NOT APPLE)
    MACRO_BOOL_TO_01(CLAPACK_FOUND USE_EXT_LIBCLAPACK)
ELSE(NOT APPLE)
    # Under MACOS-X Clapack exist in standard, but it's not suitable as well. Need investiguation here.
    SET(CLAPACK_FOUND FALSE)
ENDIF(NOT APPLE)

#-------------------------------------------------------------------------------------

=== doc/CMakeLists.txt ===
# ===========================================================
#
# This file is a part of digiKam project
# <a href="http://www.digikam.org">http://www.digikam.org</a>
#
# @date   2010-12-11
# @brief  digiKam Software Collection
#
# @author Copyright (C) 2010 by Gilles Caulier
#         <a href="mailto:caulier dot gilles at gmail dot com">caulier dot gilles at gmail dot com</a>
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# ============================================================

MACRO_OPTIONAL_ADD_SUBDIRECTORY(digikam/digikam)
MACRO_OPTIONAL_ADD_SUBDIRECTORY(digikam/showfoto)
MACRO_OPTIONAL_ADD_SUBDIRECTORY(kipi-plugins)

=== extra/CMakeLists.txt ===
# ===========================================================
#
# This file is a part of digiKam project
# <a href="http://www.digikam.org">http://www.digikam.org</a>
#
# @date   2010-12-11
# @brief  digiKam Software Collection
#
# @author Copyright (C) 2010-2011 by Gilles Caulier
#         <a href="mailto:caulier dot gilles at gmail dot com">caulier dot gilles at gmail dot com</a>
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# ============================================================

FIND_PACKAGE(KDE4 REQUIRED)
INCLUDE(MacroOptionalAddSubdirectory)

IF (${DIGIKAMSC_USE_PRIVATE_KDEGRAPHICS})
    MACRO_OPTIONAL_ADD_SUBDIRECTORY(libksane)
    ADD_SUBDIRECTORY(libkipi)
    ADD_SUBDIRECTORY(libkexiv2)
    ADD_SUBDIRECTORY(libkdcraw)
ENDIF()

MACRO_OPTIONAL_ADD_SUBDIRECTORY(libmediawiki)
MACRO_OPTIONAL_ADD_SUBDIRECTORY(libkvkontakte)

ADD_SUBDIRECTORY(libkgeomap)
ADD_SUBDIRECTORY(libkface)
ADD_SUBDIRECTORY(kipi-plugins)

=== core/imageplugins/CMakeLists.txt ===
SET_DEBUG_AREA_CODE(${AREA_CODE_IMAGEPLUGINS})

ADD_SUBDIRECTORY( color )
ADD_SUBDIRECTORY( decorate )
ADD_SUBDIRECTORY( enhance )
ADD_SUBDIRECTORY( filters )
ADD_SUBDIRECTORY( transform )

=== core/tests/CMakeLists.txt ===
SET( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

#------------------------------------------------------------------------

SET(advancedrenametest_SRCS
    advancedrenametest.cpp
   )

KDE4_ADD_UNIT_TEST(advancedrenametest ${advancedrenametest_SRCS})

TARGET_LINK_LIBRARIES(advancedrenametest
                      ${KDE4_KDEUI_LIBS}
                      ${KEXIV2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      digikamcore
                      digikamdatabase
                      advancedrename
                     )

#------------------------------------------------------------------------

SET(renamecustomizertest_SRCS
    renamecustomizertest.cpp
   )

KDE4_ADD_UNIT_TEST(renamecustomizertest ${renamecustomizertest_SRCS})

TARGET_LINK_LIBRARIES(renamecustomizertest
                      ${KDE4_KDEUI_LIBS}
                      ${KEXIV2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      digikamcore
                      digikamdatabase
importui
                      advancedrename
                     )

#------------------------------------------------------------------------

SET(cameranamehelper_SRCS
    cameranamehelpertest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/views/cameranamehelper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/backend/gpcamera.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/backend/camiteminfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/backend/dkcamera.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/utils/albumsettings.cpp
   )

KDE4_ADD_UNIT_TEST(cameranamehelpertest ${cameranamehelper_SRCS})

TARGET_LINK_LIBRARIES(cameranamehelpertest
                      ${KDE4_KDEUI_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${GPHOTO2_LIBRARIES}
                      ${KDCRAW_LIBRARIES}
                      ${KEXIV2_LIBRARIES}
                      digikamcore
                      digikamdatabase
                     )

#------------------------------------------------------------------------

SET(uifilevalidator_SRCS
    uifilevalidatortest.cpp
   )

KDE4_ADD_UNIT_TEST(uifilevalidatortest ${uifilevalidator_SRCS})

TARGET_LINK_LIBRARIES(uifilevalidatortest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${GPHOTO2_LIBRARIES}
                      digikamcore
                      digikamdatabase
                     )

#------------------------------------------------------------------------

SET(statesavingobject_SRCS
    statesavingobjecttest.cpp
   )

KDE4_ADD_UNIT_TEST(statesavingobjecttest ${statesavingobject_SRCS})

TARGET_LINK_LIBRARIES(statesavingobjecttest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${GPHOTO2_LIBRARIES}
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(freerotationtest_SRCS
    freerotationtest.cpp
   )
KDE4_ADD_UNIT_TEST(freerotationtest ${freerotationtest_SRCS})

TARGET_LINK_LIBRARIES(freerotationtest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(searchtextbartest_SRCS
    searchtextbartest.cpp
   )

KDE4_ADD_UNIT_TEST(searchtextbartest ${searchtextbartest_SRCS})

TARGET_LINK_LIBRARIES(searchtextbartest
                      ${KDE4_KDEUI_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(filesaveoptionsboxtest_SRCS
    filesaveoptionsboxtest.cpp
   )

KDE4_ADD_UNIT_TEST(filesaveoptionsboxtest ${filesaveoptionsboxtest_SRCS})

TARGET_LINK_LIBRARIES(filesaveoptionsboxtest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      digikamcore
                     )

#------------------------------------------------------------------------

#SET(albummodeltest_SRCS
#    albummodeltest.cpp
#    modeltest/modeltest.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/album/album.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/album/albummanager.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/album/albumsettings.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/album/albumthumbnailloader.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/database/databaseguierrorhandler.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/widgets/common/databasewidget.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../digikam/database/scancontroller.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/dkcamera.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/importui/gpcamera.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/cameralist.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/cameraselection.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/cameratype.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setup.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupdatabase.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupcollections.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupcollectionview.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupalbumview.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupcategory.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupfacetags.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setuptooltip.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupmetadata.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setuptemplate.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupmime.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setuplighttable.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupeditor.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupiofiles.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupdcraw.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupicc.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupplugins.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupslideshow.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupscriptmanager.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/scriptplugintype.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupversioning.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupcamera.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupmisc.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupfacetags.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/setup/setupversioning.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../utilities/batch/batchthumbsgenerator.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/models/abstractalbummodel.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/models/albumfiltermodel.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/models/albummodel.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/template/subjectedit.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/template/templatelist.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/template/templatemanager.cpp
#    ${CMAKE_CURRENT_SOURCE_DIR}/../libs/template/templatepanel.cpp
#   )
#
#KDE4_ADD_UNIT_TEST(albummodeltest ${albummodeltest_SRCS})
#
#TARGET_LINK_LIBRARIES(albummodeltest
#                      ${KDE4_KIO_LIBS}
#                      ${QT_QTGUI_LIBRARY}
#                      ${QT_QTTEST_LIBRARY}
#                      ${QT_QTXML_LIBRARY}
#                      ${QT_QTSQL_LIBRARY}
#                      ${GPHOTO2_LIBRARIES}
#                      ${KIPI_LIBRARIES}
#                      ${KDCRAW_LIBRARIES}
#                      ${KEXIV2_LIBRARIES}
#                      digikamdatabase
#                      digikamcore
#                     )


#------------------------------------------------------------------------

SET(dimagehistorytest_SRCS
    abstractdimagehistorytest.cpp
    dimagehistorytest.cpp
   )

KDE4_ADD_UNIT_TEST(dimagehistorytest ${dimagehistorytest_SRCS})

TARGET_LINK_LIBRARIES(dimagehistorytest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${KEXIV2_LIBRARIES}
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(dimagehistorygraphtest_SRCS
    abstractdimagehistorytest.cpp
    dimagehistorygraphtest.cpp
    modeltest/modeltest.cpp
   )

KDE4_ADD_UNIT_TEST(dimagehistorygraphtest ${dimagehistorygraphtest_SRCS})

TARGET_LINK_LIBRARIES(dimagehistorygraphtest
                      ${KDE4_KDECORE_LIBS}
                      ${KDE4_KIO_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${KEXIV2_LIBRARIES}
                      digikamdatabase
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(dimagefilteractiontest_SRCS
    dimagefilteractiontest.cpp
   )

KDE4_ADD_UNIT_TEST(dimagefilteractiontest ${dimagefilteractiontest_SRCS})

TARGET_LINK_LIBRARIES(dimagefilteractiontest
                      ${KDE4_KDECORE_LIBS}
                      ${QT_QTGUI_LIBRARY}
                      ${QT_QTTEST_LIBRARY}
                      ${KEXIV2_LIBRARIES}
                      digikamcore
                     )

#------------------------------------------------------------------------

SET(databasefieldstest_SRCS
    databasefieldstest.cpp
   )

#KDE4_ADD_UNIT_TEST(databasefieldstest ${databasefieldstest_SRCS})

#TARGET_LINK_LIBRARIES(databasefieldstest
#                      ${KDE4_KDECORE_LIBS}
#                      ${QT_QTGUI_LIBRARY}
#                      ${QT_QTTEST_LIBRARY}
#                      ${KEXIV2_LIBRARIES}
#                      digikamcore
#                     )

#------------------------------------------------------------------------

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../libs/threadimageio)

IF(PGF_FOUND)
    INCLUDE_DIRECTORIES(${PGF_INCLUDE_DIRS})
ELSE(PGF_FOUND)
    INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../libs/3rdparty/libpgf)
ENDIF(PGF_FOUND)

# Disable libpgf warnings.
SET_SOURCE_FILES_PROPERTIES(${libpgf_SRCS} PROPERTIES COMPILE_FLAGS "-w")

SET(qtpgftest_SRCS qtpgftest.cpp ${libpgf_SRCS} ${pgfutils_SRCS})
KDE4_ADD_EXECUTABLE(qtpgftest NOGUI ${qtpgftest_SRCS})
TARGET_LINK_LIBRARIES(qtpgftest ${OPENMP_LDFLAGS} ${KDE4_KIO_LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})
IF(PGF_FOUND)
    TARGET_LINK_LIBRARIES(qtpgftest ${PGF_LIBRARIES})
ENDIF(PGF_FOUND)

SET(pgfscaled_SRCS pgfscaled.cpp ${libpgf_SRCS} ${pgfutils_SRCS})
KDE4_ADD_EXECUTABLE(pgfscaled NOGUI ${pgfscaled_SRCS})
TARGET_LINK_LIBRARIES(pgfscaled ${OPENMP_LDFLAGS} ${KDE4_KIO_LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})
IF(PGF_FOUND)
    TARGET_LINK_LIBRARIES(pgfscaled ${PGF_LIBRARIES})
ENDIF(PGF_FOUND)

SET(loadpgfdata_SRCS loadpgfdata.cpp ${libpgf_SRCS} ${pgfutils_SRCS})
KDE4_ADD_EXECUTABLE(loadpgfdata NOGUI ${loadpgfdata_SRCS})
TARGET_LINK_LIBRARIES(loadpgfdata ${OPENMP_LDFLAGS} ${KDE4_KIO_LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY})
IF(PGF_FOUND)
    TARGET_LINK_LIBRARIES(loadpgfdata ${PGF_LIBRARIES})
ENDIF(PGF_FOUND)

#------------------------------------------------------------------------

SET(testdimgloader_SRCS testdimgloader.cpp)

=== extra/kipi-plugins/CMakeLists.txt ===
PROJECT(kipi-plugins)

MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS "Starting CMake configuration for: kipi-plugins")

# =======================================================
# Information to update before to release this package.

# kipi-plugins version
SET(KIPIPLUGINS_MAJOR_VERSION "3")
SET(KIPIPLUGINS_MINOR_VERSION "5")
SET(KIPIPLUGINS_PATCH_VERSION "0")

# kipi-plugins release date
SET (KIPIPLUGINS_RELEASE_DATE "2013-XX-XX")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final relase. Can be used in production.
SET(KIPIPLUGINS_SUFFIX_VERSION "")

# =======================================================
# Set env. variables accordinly.

SET(KIPIPLUGINS_VERSION_STRING
    "${KIPIPLUGINS_MAJOR_VERSION}.${KIPIPLUGINS_MINOR_VERSION}.${KIPIPLUGINS_PATCH_VERSION}${KIPIPLUGINS_SUFFIX_VERSION}"
   )

# =======================================================
# some useful macros for printing status information

SET(PRINT_COMPILE_LENGTH "40")
MACRO(FILL_WITH_DOTS VAR)

    STRING(LENGTH ${${VAR}} NAME_LENGTH)

    MATH(EXPR DOT_LENGTH "${PRINT_COMPILE_LENGTH} - ${NAME_LENGTH}")
    IF(${DOT_LENGTH} LESS 0)
        SET(DOT_LENGTH 0)
    ENDIF(${DOT_LENGTH} LESS 0)

    FOREACH(COUNT RANGE ${DOT_LENGTH})
        SET(${VAR} "${${VAR}}.")
    ENDFOREACH(COUNT)

ENDMACRO(FILL_WITH_DOTS)

MACRO(PRINT_PLUGIN_COMPILE_STATUS NAME)

    SET(COMPILE_MESSAGE "${NAME} will be compiled")
    FILL_WITH_DOTS(COMPILE_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${COMPILE_MESSAGE} YES (optional)")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${COMPILE_MESSAGE} NO  (optional - Look README file for more details about dependencies)")
    ENDIF(${ARGN})

ENDMACRO(PRINT_PLUGIN_COMPILE_STATUS)

MACRO(PRINT_OPTIONAL_LIBRARY_STATUS NAME)

    SET(LIB_MESSAGE "${NAME} library found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES (optional)")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO  (optional)")
    ENDIF(${ARGN})

ENDMACRO(PRINT_OPTIONAL_LIBRARY_STATUS)

MACRO(PRINT_LIBRARY_STATUS NAME WEBSITE VERSIONHINT)

    SET(LIB_MESSAGE "${NAME} library found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
        MESSAGE(STATUS "")
        MESSAGE(SEND_ERROR " kipi-plugins needs ${NAME}. You need to install the ${NAME}${VERSIONHINT} library development package.")
        MESSAGE(STATUS " ${NAME} website is at ${WEBSITE}")
        MESSAGE(STATUS "")
    ENDIF(${ARGN})

ENDMACRO(PRINT_LIBRARY_STATUS)

MACRO(PRINT_OPTIONAL_QTMODULE_STATUS NAME)

    SET(LIB_MESSAGE "${NAME} module found")
    FILL_WITH_DOTS(LIB_MESSAGE)

    IF(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} YES")
    ELSE(${ARGN})
        MESSAGE(STATUS " ${LIB_MESSAGE} NO")
    ENDIF(${ARGN})

ENDMACRO(PRINT_OPTIONAL_QTMODULE_STATUS)

# =======================================================

CMAKE_POLICY(SET CMP0017 NEW)

FIND_PACKAGE(KDE4 REQUIRED)

ADD_DEFINITIONS(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})

INCLUDE(MacroOptionalFindPackage)
INCLUDE(FindPackageHandleStandardArgs)
INCLUDE(KDE4Defaults)
INCLUDE(MacroLibrary)

# Put local modules first
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})

# Dependencies detection required by all plugins
FIND_PACKAGE(Kipi 2.0.0 REQUIRED)
FIND_PACKAGE(Kexiv2     REQUIRED)
FIND_PACKAGE(JPEG       REQUIRED)
FIND_PACKAGE(PNG        REQUIRED)
FIND_PACKAGE(TIFF       REQUIRED)
FIND_PACKAGE(Kdcraw     REQUIRED)

# Check the libkdcraw version

SET(KDCRAW_MIN_VERSION "2.2.0")

IF (KDCRAW_VERSION)

    MESSAGE(STATUS "libkdcraw: Found version ${KDCRAW_VERSION} (required: ${KDCRAW_MIN_VERSION})")
    IF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})
        SET(KDCRAW_FOUND FALSE)
    ENDIF (${KDCRAW_VERSION} VERSION_LESS ${KDCRAW_MIN_VERSION})

ELSE (KDCRAW_VERSION)

    MESSAGE(WARNING "libkdcraw: Version information not found, your version is probably too old.")
    SET(KDCRAW_FOUND FALSE)

ENDIF (KDCRAW_VERSION)

# Optional dependencies detection required by some plugins
MACRO_OPTIONAL_FIND_PACKAGE(EXPAT)                                       # For DNGConverter: XMP SDK need Expat library to compile.
MACRO_OPTIONAL_FIND_PACKAGE(Threads)                                     # For DNGConverter: DNG SDK need native threads support.
MACRO_OPTIONAL_FIND_PACKAGE(LibXml2)                                     # For Htmlexport.
MACRO_OPTIONAL_FIND_PACKAGE(LibXslt)                                     # For Htmlexport.
MACRO_OPTIONAL_FIND_PACKAGE(OpenGL)                                      # For AdvancedSlideshow and ImageViewer.
MACRO_OPTIONAL_FIND_PACKAGE(Ipod)                                        # For ipodexport.
MACRO_OPTIONAL_FIND_PACKAGE(Gdk)                                         # For ipodexport.
MACRO_OPTIONAL_FIND_PACKAGE(GLIB2)                                       # For ipodexport.
MACRO_OPTIONAL_FIND_PACKAGE(GObject)                                     # For ipodexport.
MACRO_OPTIONAL_FIND_PACKAGE(FLEX)                                        # For Panorama (must be found before KdepimLibs for MacOS).
MACRO_OPTIONAL_FIND_PACKAGE(BISON)                                       # For Panorama (must be found before KdepimLibs for MacOS).
MACRO_OPTIONAL_FIND_PACKAGE(KdepimLibs)                                  # For Calendar (libkcal).
MACRO_OPTIONAL_FIND_PACKAGE(QCA2)                                        # For Shwup and YandexFotki.
MACRO_OPTIONAL_FIND_PACKAGE(KSane)                                       # For AcquireImages.
MACRO_OPTIONAL_FIND_PACKAGE(OpenCV)                                      # For RemoveRedEyes.
MACRO_OPTIONAL_FIND_PACKAGE(QJSON)                                       # For Debian Screenshots Facebook, and Imgur.
MACRO_OPTIONAL_FIND_PACKAGE(KGeoMap)                                     # For GPSSync.
MACRO_OPTIONAL_FIND_PACKAGE(Mediawiki)                                   # For Mediawiki.
MACRO_OPTIONAL_FIND_PACKAGE(LibKVkontakte)                               # For VKontakte.
MACRO_OPTIONAL_FIND_PACKAGE(Hupnp)                                       # For DlnaExport.
MACRO_OPTIONAL_FIND_PACKAGE(ImageMagick COMPONENTS MagickCore display)   # For VideoSlideshow.
MACRO_OPTIONAL_FIND_PACKAGE(QtGStreamer)                                 # For VideoSlideshow.
MACRO_OPTIONAL_FIND_PACKAGE(QtKOAuth)                                     # For Imgur Auhtenticated API

# check the libkgeomap version
# note that old versions don't specify version information, so for now
# just inform the user if version information was found
IF (KGEOMAP_VERSION)
    MESSAGE(STATUS "libkgeomap: Found version ${KGEOMAP_VERSION}")
    # TODO: fail if the version is too low
ENDIF (KGEOMAP_VERSION)

# X11 check, LINUX Only.
IF(NOT WIN32 AND NOT APPLE)
    MACRO_OPTIONAL_FIND_PACKAGE(X11)   # For AdvancedSlideshow and ImageViewer.
ENDIF(NOT WIN32 AND NOT APPLE)

# SPECIAL OPENCV HANDLING

# there are two versions of FindOpenCV.cmake in the wild, one defining
# OpenCV_LIBRARIES, the other defining OpenCV_LIBS. Make sure we handle
# both cases.
IF (NOT OpenCV_LIBRARIES)
    SET(OpenCV_LIBRARIES ${OpenCV_LIBS})
ENDIF (NOT OpenCV_LIBRARIES)

# same story with OpenCV_INCLUDE_DIRS and OpenCV_INCLUDE_DIR:
IF (NOT OpenCV_INCLUDE_DIRS)
    SET(OpenCV_INCLUDE_DIRS ${OpenCV_INCLUDE_DIR})
ENDIF (NOT OpenCV_INCLUDE_DIRS)

IF (OpenCV_LIBRARIES AND OpenCV_INCLUDE_DIRS)
    SET (OpenCV_FOUND TRUE)
ENDIF (OpenCV_LIBRARIES AND OpenCV_INCLUDE_DIRS)

# OpenMP detection requires CMake >= 2.6.3

EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} --version OUTPUT_VARIABLE VERSION_CMAKE_INFO)
MESSAGE(STATUS "CMake version: ${VERSION_CMAKE_INFO}")
STRING(REPLACE "-patch " "." VERSION_CMAKE_INFO "${VERSION_CMAKE_INFO}")
MESSAGE(STATUS "CMake version (cleaned): ${VERSION_CMAKE_INFO}")
MACRO_ENSURE_VERSION("2.6.3" "${VERSION_CMAKE_INFO}" OPENMP_VERSION_CMAKE)

IF(OPENMP_VERSION_CMAKE AND NOT APPLE)
    MACRO_OPTIONAL_FIND_PACKAGE(OpenMP)
ELSE(OPENMP_VERSION_CMAKE AND NOT APPLE)
    MESSAGE(STATUS "CMake version is too old: cannot detected OpenMP. Some plugins may have a weaker performance without OpenMP.")
ENDIF(OPENMP_VERSION_CMAKE AND NOT APPLE)

INCLUDE(MacroOptionalDependPackage)

# ==================================================================================================
# Log messages

MESSAGE(STATUS "")
MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS " kipi-plugins ${KIPIPLUGINS_VERSION_STRING} dependencies results   <http://www.digikam.org>")
MESSAGE(STATUS "")

# Require shared libraries results.

PRINT_LIBRARY_STATUS("libjpeg"   "http://www.ijg.org"                        ""                                    JPEG_FOUND)
PRINT_LIBRARY_STATUS("libtiff"   "http://www.remotesensing.org/libtiff"      ""                                    TIFF_FOUND)
PRINT_LIBRARY_STATUS("libpng"    "http://www.libpng.org/pub/png/libpng.html" " (version >= 1.2.7)"                 PNG_FOUND)
PRINT_LIBRARY_STATUS("libkipi"   "http://www.digikam.org/sharedlibs"         " (version >= ${KIPI_MIN_VERSION})"   KIPI_FOUND)
PRINT_LIBRARY_STATUS("libkexiv2" "http://www.digikam.org/sharedlibs"         " (version >= 1.2.0)"                 KEXIV2_FOUND)
PRINT_LIBRARY_STATUS("libkdcraw" "http://www.digikam.org/sharedlibs"         " (version >= ${KDCRAW_MIN_VERSION})" KDCRAW_FOUND)

# Optional shared libraries results.

PRINT_OPTIONAL_LIBRARY_STATUS("libxml2"                LIBXML2_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libxslt"                LIBXSLT_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libexpat"               EXPAT_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("native threads support" CMAKE_USE_PTHREADS_INIT OR CMAKE_USE_WIN32_THREADS_INIT)
PRINT_OPTIONAL_LIBRARY_STATUS("libopengl"              OPENGL_FOUND AND OPENGL_GLU_FOUND)
PRINT_OPTIONAL_QTMODULE_STATUS("Qt4 OpenGL"            QT_QTOPENGL_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libopencv"              OpenCV_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("QJson"                  QJSON_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libgpod"                IPOD_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("Gdk"                    GDK_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libkdepim"              KDEPIMLIBS_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("qca2"                   QCA2_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libkgeomap"             KGEOMAP_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libmediawiki"           MEDIAWIKI_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libkvkontakte"          LIBKVKONTAKTE_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libimagemagick"         ImageMagick_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("libqtgstreamer"         QTGSTREAMER_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("QtKOAuth"               QTKOAUTH_FOUND)

IF(OPENMP_VERSION_CMAKE)
    PRINT_OPTIONAL_LIBRARY_STATUS("OpenMP" OPENMP_FOUND)
ENDIF(OPENMP_VERSION_CMAKE)

# LINUX Only.
IF(NOT WIN32 AND NOT APPLE)
    PRINT_OPTIONAL_LIBRARY_STATUS("libX11" X11_FOUND AND X11_Xrandr_FOUND)
ENDIF(NOT WIN32 AND NOT APPLE)

PRINT_OPTIONAL_LIBRARY_STATUS("libksane" KSANE_FOUND)

IF(HUPNP_FOUND)
    MESSAGE(STATUS " Hupnp library found...................... YES (optional)")
ELSE(HUPNP_FOUND)
    MESSAGE(STATUS " Hupnp library found...................... NO  (optional - internal version used instead)")
ENDIF(HUPNP_FOUND)

# Optional plugins results ----------------------------------------------------------------------------

MESSAGE(STATUS "")

IF(JPEG_FOUND AND PNG_FOUND AND TIFF_FOUND AND KDCRAW_FOUND AND KEXIV2_FOUND AND KIPI_FOUND)
    SET(KIPI_COMPILE_MESSAGE "kipi-plugins will be compiled")
    FILL_WITH_DOTS(KIPI_COMPILE_MESSAGE)

=== extra/libkface/CMakeLists.txt ===
# ===========================================================
#
# This file is a part of digiKam project
# <a href="http://www.digikam.org">http://www.digikam.org</a>
#
# @date   2010-06-16
# @brief  LibFace library interface for KDE
#
# @author Copyright (C) 2010-2013 by Gilles Caulier
#         <a href="mailto:caulier dot gilles at gmail dot com">caulier dot gilles at gmail dot com</a>
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# ============================================================

PROJECT(libkface)

MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS "Starting CMake configuration for: libkface")

FIND_PACKAGE(Qt4 4.6.0 REQUIRED)
FIND_PACKAGE(KDE4 REQUIRED)

ADD_DEFINITIONS(${KDE4_ENABLE_EXCEPTIONS})
ADD_DEFINITIONS(${LIBFACE_DEFINITIONS})
ADD_DEFINITIONS(${KDE4_ENABLE_EXCEPTIONS})

SUBDIRS(OpenTLD)

INCLUDE(KDE4Defaults)
INCLUDE(MacroLibrary)
INCLUDE(MacroOptionalAddSubdirectory)
INCLUDE(MacroOptionalFindPackage)
INCLUDE(FindPackageHandleStandardArgs)

ADD_DEFINITIONS (${QT_DEFINITIONS} ${QT_QTDBUS_DEFINITIONS} ${KDE4_DEFINITIONS} -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS )
INCLUDE_DIRECTORIES (${QDBUS_INCLUDE_DIRS} ${KDE4_INCLUDES})

SET(LIBKFACE_AREA_CODE_GENERAL 51005)
ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${LIBKFACE_AREA_CODE_GENERAL})

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# BEGIN SPECIAL OPENCV HANDLING

# On some systems, OpenCV can be found using FIND_PACKAGE(OpenCV), for other systems
# we ship our own version of FindOpenCV.cmake. But that does not work on all systems.
# Therefore, first try finding OpenCV using FIND_PACKAGE(OpenCV), and if that fails,
# add our FindOpenCV.cmake to the search path and search again.

MESSAGE(STATUS "First try at finding OpenCV...")
FIND_PACKAGE(OpenCV)

IF (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)
  MESSAGE(STATUS "Could not find OpenCV normally, trying internal FindOpenCV.cmake")
  SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules_opencv)
  FIND_PACKAGE(OpenCV REQUIRED)
ELSE (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)
  MESSAGE(STATUS "Great, found OpenCV on the first try.")
ENDIF (NOT OpenCV_LIBRARIES AND NOT OpenCV_LIBS)

MESSAGE(STATUS "OpenCV Root directory is: ${OpenCV_DIR}")

# check OpenCV version

# Libkface can be compiled with OpenCV 2.4.3, but at least 2.4.5 is suitbale without main bugs for Faces Recognition.
SET(OPENCV_MIN_VERSION "2.4.5")

IF (OpenCV_VERSION)

    MESSAGE(STATUS "OpenCV: Found version ${OpenCV_VERSION} (required: ${OPENCV_MIN_VERSION})")
    IF (${OpenCV_VERSION} VERSION_LESS ${OPENCV_MIN_VERSION})
        MESSAGE(WARNING "OpenCV: Version is too old.")
        SET(OpenCV_FOUND FALSE)
    ENDIF (${OpenCV_VERSION} VERSION_LESS ${OPENCV_MIN_VERSION})

ELSE (OpenCV_VERSION)

    MESSAGE(WARNING "OpenCV: Version information not found, your version is probably too old.")
    SET(OpenCV_FOUND FALSE)

ENDIF (OpenCV_VERSION)



# there are two versions of FindOpenCV.cmake in the wild, one defining
# OpenCV_LIBRARIES, the other defining OpenCV_LIBS. Make sure we handle
# both cases.
IF (NOT OpenCV_LIBRARIES)
  SET(OpenCV_LIBRARIES ${OpenCV_LIBS})
ENDIF (NOT OpenCV_LIBRARIES)

# same story with OpenCV_INCLUDE_DIRS and OpenCV_INCLUDE_DIR:
IF (NOT OpenCV_INCLUDE_DIRS)
  SET(OpenCV_INCLUDE_DIRS ${OpenCV_INCLUDE_DIR})
ENDIF (NOT OpenCV_INCLUDE_DIRS)

# END SPECIAL OPENCV HANDLING

INCLUDE_DIRECTORIES(${OpenCV_INCLUDE_DIRS})

IF (OpenCV_FOUND)

# =======================================================
# Information to update before to release this library.

# Library version history:
# API      ABI
# 0.1.0 => 0.1.0     (During digiKam GoSC2010)
# 2.0.0 => 1.0.0     (Included into digiKam 2.0.0 Software Collection)
# 3.0.0 => 2.0.0     (Including OpenTLD for face recognition)

# Library API version
SET(KFACE_LIB_MAJOR_VERSION "3")
SET(KFACE_LIB_MINOR_VERSION "0")
SET(KFACE_LIB_PATCH_VERSION "0")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final relase. Can be used in production.
SET(KFACE_LIB_SUFFIX_VERSION "")

# Library ABI version used by linker.
# For details : http://www.gnu.org/software/libtool/manual/libtool.html#Updating-version-info
SET(KFACE_LIB_SO_CUR_VERSION "2")
SET(KFACE_LIB_SO_REV_VERSION "0")
SET(KFACE_LIB_SO_AGE_VERSION "0")

# =======================================================
# Set env. variables accordinly.

SET(KFACE_LIB_VERSION_STRING "${KFACE_LIB_MAJOR_VERSION}.${KFACE_LIB_MINOR_VERSION}.${KFACE_LIB_PATCH_VERSION}${KFACE_LIB_SUFFIX_VERSION}")
SET(KFACE_LIB_VERSION_ID "0x0${KFACE_LIB_MAJOR_VERSION}0${KFACE_LIB_MINOR_VERSION}0${KFACE_LIB_PATCH_VERSION}")
SET(KFACE_LIB_SO_VERSION_STRING "${KFACE_LIB_SO_CUR_VERSION}.${KFACE_LIB_SO_REV_VERSION}.${KFACE_LIB_SO_AGE_VERSION}")

# =======================================================

SUBDIRS(libkface)
SUBDIRS(test)
SUBDIRS(data)

IF(NOT WIN32)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libkface.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libkface.pc)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libkface.lsm.cmake ${CMAKE_CURRENT_BINARY_DIR}/libkface.lsm)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libkface.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig )
ENDIF(NOT WIN32)

# Install find cmake script to the system for client applications.

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/FindKface.cmake
        DESTINATION ${DATA_INSTALL_DIR}/cmake/modules)

ELSE(OpenCV_FOUND)
    MESSAGE(FATAL_ERROR "LibKface cannot be compiled.")
ENDIF(OpenCV_FOUND)

=== extra/libkvkontakte/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6.4)
project(kvkontakte)

# the version number, needed for
# - the library version
# - version detection by cmake
set(LIBKVKONTAKTE_VERSION_MAJOR 1)
set(LIBKVKONTAKTE_VERSION_MINOR 0)
set(LIBKVKONTAKTE_VERSION_PATCH 0)
set(LIBKVKONTAKTE_VERSION ${LIBKVKONTAKTE_VERSION_MAJOR}.${LIBKVKONTAKTE_VERSION_MINOR}.${LIBKVKONTAKTE_VERSION_PATCH} )
# TODO: calculate the version id properly (here is currently a hack that won't work for 1.10.0):
set(LIBKVKONTAKTE_VERSION_ID "0x0${LIBKVKONTAKTE_VERSION_MAJOR}0${LIBKVKONTAKTE_VERSION_MINOR}0${LIBKVKONTAKTE_VERSION_PATCH}")

if(NOT LIB_INSTALL_DIR)
	set(LIB_INSTALL_DIR lib${LIB_SUFFIX})
endif(NOT LIB_INSTALL_DIR)
set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/LibKVkontakte )

# Use a versioned install directory for the headers so multiple versions can be installed in parallel
set(INCLUDE_INSTALL_DIR include )


# === Closer to the code, close to the body ===
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
find_package(KDE4 REQUIRED)
include(KDE4Defaults)
include(MacroLibrary)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${KDE4_ENABLE_EXCEPTIONS}")

set(QJSON_VERSION_REQUIRED 0.7)
find_package(QJSON ${QJSON_VERSION_REQUIRED})
macro_log_feature(QJSON_FOUND "QJSON" "Qt library for handling JSON data" "http://qjson.sourceforge.net/" TRUE "${QJSON_VERSION_REQUIRED}")

add_definitions(${QT_DEFINITIONS} ${KDE4_DEFINITIONS})

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${KDE4_INCLUDES}
  ${QJSON_INCLUDE_DIR}
)

add_subdirectory(libkvkontakte)
# === ------------------------------------- ===

# This "exports" all targets which have been put into the export set "LibKVkontakteExport".
# This means that cmake generates a file with the given filename, which can later on be loaded
# by projects using this package.
# This file contains add_library(bar IMPORTED) statements for each target in the export set, so
# when loaded later on cmake will create "imported" library targets from these, which can be used
# in many ways in the same way as a normal library target created via a normal add_library().
install(EXPORT LibKVkontakteExport DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE LibKVkontakteTargets.cmake )

# figure out the relative path from the installed Config.cmake file to the install prefix (which may be at
# runtime different from the chosen CMAKE_INSTALL_PREFIX if under Windows the package was installed anywhere)
# This relative path will be configured into the LibKVkontakteConfig.cmake
file(RELATIVE_PATH relInstallDir ${CMAKE_INSTALL_PREFIX}/${CMAKECONFIG_INSTALL_DIR} ${CMAKE_INSTALL_PREFIX} )

# Create a LibKVkontakteConfig.cmake file. <name>Config.cmake files are searched by find_package()
# automatically. We configure that file so that we can put any information we want in it,
# e.g. version numbers, include directories, etc.
configure_file(LibKVkontakteConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibKVkontakteConfig.cmake @ONLY )

# Additionally, when cmake has found a LibKVkontakteConfig.cmake, it can check for a LibKVkontakteConfigVersion.cmake
# in the same directory when figuring out the version of the package when a version
# has been specified in the find_package() call, e.g. find_package(LibKVkontakte 1.0)
configure_file(LibKVkontakteConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibKVkontakteConfigVersion.cmake @ONLY )

# Install these two files into the same directory as the generated exports-file.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibKVkontakteConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/LibKVkontakteConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR} )


macro_display_feature_log()

=== extra/libmediawiki/CMakeLists.txt ===
# ===========================================================
#
# This file is a part of KDE project
# <a href="https://projects.kde.org/projects/extragear/libs/libmediawiki">libmediawiki</a>
#
# @date   2011-03-24
# @brief  a MediaWiki C++ interface for KDE
#
# @author Copyright (C) 2011-2012 by Gilles Caulier
#         <a href="mailto:caulier dot gilles at gmail dot com">caulier dot gilles at gmail dot com</a>
#
# This program is free software; you can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# ============================================================

PROJECT(libmediawiki)

MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS "Starting CMake configuration for: libmediawiki")

FIND_PACKAGE(KDE4 REQUIRED)

INCLUDE(KDE4Defaults)
INCLUDE(MacroLibrary)
INCLUDE(MacroOptionalAddSubdirectory)
INCLUDE(MacroOptionalFindPackage)
INCLUDE(FindPackageHandleStandardArgs)

ADD_DEFINITIONS (${QT_DEFINITIONS} ${QT_QTDBUS_DEFINITIONS} ${KDE4_DEFINITIONS})
INCLUDE_DIRECTORIES (${QDBUS_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${KDE4_INCLUDES})

SET(LIBMEDDIAWIKI_AREA_CODE_GENERAL 51007)
ADD_DEFINITIONS(-DKDE_DEFAULT_DEBUG_AREA=${LIBMEDDIAWIKI_AREA_CODE_GENERAL})

# =======================================================
# Information to update before to release this library.

# Library version history:
# API      ABI
# 1.0.0 => 1.0.0  (released with KDE 4.7.0)

# Library API version
SET(MEDIAWIKI_LIB_MAJOR_VERSION "1")
SET(MEDIAWIKI_LIB_MINOR_VERSION "0")
SET(MEDIAWIKI_LIB_PATCH_VERSION "0")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final relase. Can be used in production.
SET(MEDIAWIKI_LIB_SUFFIX_VERSION "")

# Library ABI version used by linker.
# For details : http://www.gnu.org/software/libtool/manual/libtool.html#Updating-version-info
SET(MEDIAWIKI_LIB_SO_CUR_VERSION "1")
SET(MEDIAWIKI_LIB_SO_REV_VERSION "0")
SET(MEDIAWIKI_LIB_SO_AGE_VERSION "0")

# =======================================================
# Set env. variables accordinly.

SET(MEDIAWIKI_LIB_VERSION_STRING "${MEDIAWIKI_LIB_MAJOR_VERSION}.${MEDIAWIKI_LIB_MINOR_VERSION}.${MEDIAWIKI_LIB_PATCH_VERSION}${MEDIAWIKI_LIB_SUFFIX_VERSION}")
SET(MEDIAWIKI_LIB_VERSION_ID "0x0${MEDIAWIKI_LIB_MAJOR_VERSION}0${MEDIAWIKI_LIB_MINOR_VERSION}0${MEDIAWIKI_LIB_PATCH_VERSION}")

SET(MEDIAWIKI_LIB_SO_VERSION_STRING "${MEDIAWIKI_LIB_SO_CUR_VERSION}.${MEDIAWIKI_LIB_SO_REV_VERSION}.${MEDIAWIKI_LIB_SO_AGE_VERSION}")

# =======================================================

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

ADD_SUBDIRECTORY(libmediawiki)
ADD_SUBDIRECTORY(samplecode)
ADD_SUBDIRECTORY(tests)

IF(NOT WIN32)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libmediawiki.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libmediawiki.pc)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libmediawiki.lsm.cmake ${CMAKE_CURRENT_BINARY_DIR}/libmediawiki.lsm)
  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libmediawiki.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig )
ENDIF(NOT WIN32)

# Install find cmake script to the system for client applications.

INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/FindMediawiki.cmake
        DESTINATION ${DATA_INSTALL_DIR}/cmake/modules)

=== po/csb/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( csb ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== po/ha/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( ha ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== po/ku/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES( ku ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== debian/changelog ===
digikam (4:3.5.0-0ubuntu10) trusty; urgency=medium

  * No change rebuild for libmarblewidget16 transition

 -- Scott Kitterman <scott@kitterman.com>  Fri, 21 Mar 2014 00:35:01 -0400

digikam (4:3.5.0-0ubuntu9) trusty; urgency=medium

  * Add upstream_Panorama-bugfix-lastpage.patch from upstream to fix a crash
    in the panorama gui. LP: #1283761, KDE BUG: #326728
    + Patch paths manually adjusted since the git source is not in digikam. 

 -- Harald Sitter <apachelogger@kubuntu.org>  Sun, 23 Feb 2014 18:03:24 +0100

digikam (4:3.5.0-0ubuntu8) trusty; urgency=medium

  * Drop duplicate libgphoto2-6-dev build dependency.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Feb 2014 09:58:40 +0100

digikam (4:3.5.0-0ubuntu7) trusty; urgency=medium

  * Build against libgphoto2-dev instead of libgphoto2-6-dev. (Reverts Ubuntu
    specific delta)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Feb 2014 09:15:12 +0100

digikam (4:3.5.0-0ubuntu6) trusty; urgency=low

  * Digikam suggests libqt4-sql-mysql (this has no actual user facing impact
    even though it is the correct relationship packaging-wise) LP: #1270389

 -- Harald Sitter <apachelogger@kubuntu.org>  Mon, 20 Jan 2014 11:03:44 +0100

digikam (4:3.5.0-0ubuntu5) trusty; urgency=low

  * Drop libsqlite0-dev build-dependency.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sat, 07 Dec 2013 16:16:37 +0000

digikam (4:3.5.0-0ubuntu4) trusty; urgency=low

  * Whitelist architechtures for the Build Depend on valgrind
    since valgrind is not built for all architechtures

 -- Rohan Garg <rohangarg@kubuntu.org>  Tue, 03 Dec 2013 15:53:06 +0100

digikam (4:3.5.0-0ubuntu3) trusty; urgency=low

  * No change rebuild for libmarble transition

 -- Rohan Garg <rohangarg@kubuntu.org>  Tue, 03 Dec 2013 15:30:33 +0100

digikam (4:3.5.0-0ubuntu2) trusty; urgency=low

  * Bump to boost1.54.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Fri, 25 Oct 2013 01:02:36 +0100

digikam (4:3.5.0-0ubuntu1) trusty; urgency=low

  * New upstream release
  * debian/watch: Drop svn-upgrade command since we don't use SVN

 -- Michał Zając <quintasan@kubuntu.org>  Wed, 23 Oct 2013 16:34:46 +0200

=== debian/control ===
Source: digikam
Section: graphics
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Achim Bohnet <ach@mpe.mpg.de>, Mark Purcell <msp@debian.org>, Fathi Boudra <fabo@debian.org>
Build-Depends: debhelper (>= 9), pkg-kde-tools (>= 0.9), pkg-config, cmake (>= 2.6.2),
 doxygen,
 kdelibs5-dev (>= 4:4.10), kdepimlibs5-dev (>= 4:4.10),
 libmarble-dev (>= 4:4.10),
 libkipi-dev (>= 4:4.10), libkexiv2-dev (>= 4:4.10), libkdcraw-dev (>= 4:4.10), libksane-dev (>= 4:4.10),
 libqt4-dev, libqt4-opengl-dev [!armhf], libgl1-mesa-dev [!armhf], libglu1-mesa-dev [!armhf],
 libqtwebkit-dev, libqtgstreamer-dev,
 libgphoto2-dev,
 libmagickcore-dev, imagemagick,
 libhupnp-dev,
 libgtk2.0-dev,
 libxslt1-dev | libxslt-dev, libxml2-dev,
 libgpod-nogtk-dev,
 libqca2-dev,
 libqjson-dev,
 libpng-dev, libtiff-dev, libjpeg-dev,
 libsane-dev,
 shared-desktop-ontologies,
 mysql-server-core-5.5 | mysql-server-core,
 libglib2.0-dev,
 liblcms2-dev, liblqr-1-0-dev,
 libopencv-dev (>= 2.4.4),
 libjasper-dev,
 liblensfun-dev (>= 0.2.7),
 libexiv2-dev,
 libsqlite3-dev,
 libpgf-dev,
 flex, bison, libeigen3-dev,
 libboost-graph1.54-dev,
 libx11-dev, libxrandr-dev, libexpat1-dev | libexpat-dev,
 dh-apparmor,
 valgrind [amd64 armel armhf i386 mips mipsel powerpc ppc64 s390x x32],
 libusb-dev
Build-Conflicts: libgraphicsmagick1-dev
Standards-Version: 3.8.4
Vcs-Bzr: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/digikam
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-packagers/kubuntu-packaging/digikam
X-Debian-Vcs-Svn: svn://svn.debian.org/pkg-kde/kde-extras/digikam/trunk
X-Debian-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/digikam/trunk/
Homepage: http://www.digikam.org

Package: digikam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, libqt4-sql-sqlite, digikam-data (= ${source:Version})
Recommends: www-browser, kipi-plugins, ffmpegthumbs | mplayerthumbs
Suggests: digikam-doc, systemsettings, libqt4-sql-mysql
Conflicts: ${digikam:Conflicts}
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable digital asset management
 (DAM) software including powerful image editing functions. 
 .
 An easy-to-use camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam. 
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the KDE Image Plugins Interface (manual) 
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow. 
 .
 New Features of the KDE4 version:
  Runs on any platform that supports Qt4 and KDE4
  Supports XMP metadata
  Reads, writes and converts into DNG format
  New RAW processing tool, gamma-correction in 16 bits
  Preview of video and audio files
  Database file is independent of photo libraries, enabling remote paths,
   multiple roots and offline archives
  Improved database with many more metadata that can be searched
  Marble integration, geographical filtering with the mouse on the map
  New search finds duplicates and similar images
  Help menu lists all RAW formats and digiKam component versions
  DNG, RWL, NEF and PEF RAW file can be metadata edited
  Usability improvements for netbooks
  Non-modal image editor
  Thumbnail bar in preview mode
  Live search boxes in both sidebars and main window
  New camera interface, capture tool, scanner interface
  New plugin based on lensfun for automatic lens error corrections
 .
 digiKam can also make use of the KIPI image handling plugins to
 extend its capabilities even further for photo manipulations,
 import and export, etc. The kipi-plugins package contains many
 very useful extensions.

Package: showfoto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, digikam (= ${binary:Version})
Recommends: dolphin, kipi-plugins
Breaks: kipi-plugins-common (<< 4:3.1.0-2~)
Replaces: kipi-plugins-common (<< 4:3.1.0-2~)
Description: image viewer/editor for KDE
 showFoto is the standalone image editor of the digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}, digikam (= ${binary:Version}), showfoto (= ${binary:Version}), kdelibs5-dbg
Priority: extra
Description: debugging symbols for digiKam
 The debugging symbols associated with digiKam and showFoto. They will
 automatically be used by GDB for debugging digiKam-related issues.
 .
 This package should be installed if you wish to obtain a backtrace with 
 symbols.

Package: digikam-data
Architecture: all
Depends: ${misc:Depends}
Breaks: kipi-plugins-common (<< 4:3.1.0-2~)
Replaces: kipi-plugins-common (<< 4:3.1.0-2~)
Conflicts: ${digikam:Conflicts}
Description: digiKam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digiKam.
 .
 It has been placed in an architecture all file to reduce space on the
 archives, rather than one copy for each architecture.

Package: digikam-doc
Architecture: all
Depends: ${misc:Depends}, khelpcenter4
Recommends: digikam
Section: doc
Description: handbook for digiKam 
 digiKam is an easy to use and powerful digital photo management
 application.
 .
 This package contains the handbooks for digiKam and kipi-plugins.

Package: kipi-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kipi-plugins-common (= ${source:Version})
Breaks: digikam (<< 4:3.4.0), kipi-plugins-common (<< 4:3.1.0-3ubuntu1~)
Replaces: digikam (<< 4:3.4.0), kipi-plugins-common (<< 4:3.1.0-3ubuntu1~)
Recommends: imagemagick, hugin, enblend, enfuse, minidnla
Suggests: gallery, gimp, kmail, vorbis-tools
Enhances: digikam, gwenview, kphotoalbum, showimg
Description: image manipulation/handling plugins for KIPI aware programs
 KIPI plugins (KDE Image Plugin Interface) is an effort to develop a
 common plugin structure for digiKam, KPhotoAlbum (formerly known as
 KimDaBa), Showimg and Gwenview.
 Its aim is to share image plugins among graphic applications.
 .
 Current plugins ported to Qt4/KDE4:
 .
  AcquireImages      : acquire images using flat scanner
  Calendar           : create calendars
  DngConverter       : convert Raw Image to Digital NeGative
  Facebook           : import/export images to/from a remote Facebook
  FlickrExport       : export images to a remote Flickr based web service
  GalleryExport      : export images to a remote Gallery (and Gallery 2)
  GPSSync            : geolocalize pictures
  HTMLExport         : export images collections into a static XHTML page
  ImageViewer        : preview images using OpenGL
  JpegLossLess       : rotate/flip images without losing quality
  MetadataEdit       : edit EXIF, IPTC and XMP metadata
  PicasaWebExport    : export images to a remote Picasa web service
  PrintImage         : print images in various format
  RawConverter       : convert Raw Image to JPEG/PNG/TIFF
  RemoveRedEyes      : remove red eyes on image automatically
  SendImages         : send images by e-mail
  SimpleViewerExport : export images to Flash using SimpleViewer
  SlideShow          : Slide images with 2D and 3D effects using OpenGL
  Smug               : import/export images to/from a remote SmugMug
  TimeAdjust         : adjust date and time
  IpodExport         : export pictures to an Ipod device
  BatchProcess       : batch process images (convert, resize, rename, etc.)
  KIOExport          : export images to remote computer using network protocol
  Shwup              : export images to Shwup web service
  ExpoBlending       : create pseudo HDR image with a stack of bracketed images
  PiwigoExport       : export images to a remote Piwigo 
  DebianScreenshots  : export images to Debian Screenshots web service
  Kopete             : export images to an instant messaging contact
  YandexFotki        : export images to Yandex web service
  MediaWiki          : export images to Mediawiki based web service
  RajceExport        : export images to Rajce web service
  Vkontakte          : export images to VKontakte web service
  PhotoLayoutEditor  : assemble images together
  ImageShackExport   : export images to ImageShack web service
  ImgurExport        : export images to ImgUr web service
  DLNAExport         : export collection on DLNA network service 
 .
 Porting under progress to Qt4/KDE4:
 .
  WallPaper          : set image as background on your desktop
 .
 Not yet ported to Qt4/KDE4:
 .
  CDArchiving        : archive your image collections to a CD or DVD
  MpegEncoder        : create an MPEG slideshow with a set of images

Package: kipi-plugins-common
Architecture: all
Depends: ${misc:Depends}
Breaks: digikam (<< 4:2.3.0-2~), digikam-data (<< 4:3.1.0-3ubuntu1~)
Replaces: digikam (<< 4:2.3.0-2~), digikam-data (<< 4:3.1.0-3ubuntu1~)
Conflicts: ${digikam:Conflicts}
Description: kipi-plugins architecture-independent data
 KIPI plugins (KDE Image Plugin Interface) is an effort to develop a
 common plugin structure for digiKam, KPhotoAlbum (formerly known as
 KimDaBa), Showimg and Gwenview.
 Its aim is to share image plugins among graphic applications.
 .
 The architecture independent data needed for the kipi-plugins package.

Package: libkface2
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}, libkface-data
Description: LibFace wrapper for Qt/C++
 Libkface is a Qt/C++ wrapper around LibFace library to perform face 
 recognition and detection over pictures
 .
 This package contains the shared library to be used by applications.

Package: libkface-data
Architecture: all
Section: libs
Depends: ${misc:Depends}
Description: Data files for libkface
 Libkface is a Qt/C++ wrapper around LibFace library to perform face 
 recognition and detection over pictures
 .
 This package contains the data files of the LibKFace library

Package: libkface-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, libkface2 (= ${binary:Version})
Description: Development files for libkface
 Libkface is a Qt/C++ wrapper around LibFace library to perform face 
 recognition and detection over pictures
 .
 This package contains the development headers and files needed to create
 applications that use the LibKFace library

Package: libkgeomap1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}, libkgeomap-data
Description: World-map wrapper to browse and arrange photos over a map
 Libkgeomap is a wrapper around different world-map components, to browse and
 arrange photos over a map.
 .
 Currently supported map engines are:
  - Marble
  - OpenstreetMap (via Marble)
  - GoogleMap
 .
 This package contains the shared library to be used by applications.

Package: libkgeomap-data
Architecture: all
Section: libs
Depends: ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

USE_PRIVATE_KDEGRAPHICS := n
PRIVATE_LIBDIR := /usr/lib/digikam
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifeq ($(USE_PRIVATE_KDEGRAPHICS),y)
  EXTRA_CMAKE_ARGS += -DDIGIKAMSC_USE_PRIVATE_KDEGRAPHICS=ON
  CONFLICTS_SUBSTVAR := libkipi-data, libkexiv2-data, libkdcraw-data, libksane-data
else
  EXTRA_CMAKE_ARGS += -DDIGIKAMSC_USE_PRIVATE_KDEGRAPHICS=OFF
endif

DEB_VERSION_UPSTREAM_REVISION := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed -e 's/^[0-9]*://')
DEB_VERSION_UPSTREAM := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed -e 's/-[^-]*$$//' | sed -e 's/^[0-9]*://')

%:
	dh $@ --with kde --parallel 

# : Force to use local libkipi, libkexiv2, and libkdcraw implementation

override_dh_auto_configure:
	dh_auto_configure --buildsystem=kde -- \
	  -DCMAKE_INSTALL_RPATH="$(PRIVATE_LIBDIR)" \
	  -DDIGIKAMSC_COMPILE_DOC=on \
	  -DDIGIKAMSC_COMPILE_PO=on \
	  -DENABLE_LCMS2=ON \
	  -DKDE4_BUILD_TESTS=OFF \
	  $(EXTRA_CMAKE_ARGS)

override_dh_installchangelogs:
	dh_installchangelogs -pdigikam core/ChangeLog
	dh_installchangelogs -pkipi-plugins extra/kipi-plugins/ChangeLog
	dh_installchangelogs --remaining-packages

override_dh_installinit:
	dh_installinit
	dh_apparmor -pdigikam --profile-name=usr.sbin.mysqld-digikam

override_dh_install:
	dh_install -Xmultithread -XREADME.MACOSX --list-missing
	install -m 644 -p -D debian/usr.sbin.mysqld-digikam \
		debian/digikam/etc/apparmor.d/usr.sbin.mysqld-digikam
	install -m 755 -p -D debian/mysqld-digikam \
		debian/digikam/usr/sbin/mysqld-digikam

override_dh_shlibdeps:
	dh_shlibdeps -Xusr/lib/kde4/ -l$(CURDIR)/debian/digikam-private-libs/$(PRIVATE_LIBDIR):$(CURDIR)/debian/kipi-plugins/$(PRIVATE_LIBDIR)

override_dh_gencontrol:
	dh_gencontrol -plibkface2 -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkface-data -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkface-dev -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkgeomap1 -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkgeomap-data -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkgeomap-dev -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibmediawiki1 -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibmediawiki-dev -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkvkontakte1 -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol -plibkvkontakte-dev -- -v1.0~digikam$(DEB_VERSION_UPSTREAM_REVISION) -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'
	dh_gencontrol --remaining-packages -- -Vdigikam:Conflicts='$(CONFLICTS_SUBSTVAR)'

override_dh_strip:
	# Don't include the libraries in the debug package to prevent file conflicts
	# in the future. We have -dbgsym packages anyway.
	dh_strip -plibkface2 -plibkgeomap1 -plibmediawiki1 -plibkvkontakte1
	dh_strip --remaining-packages --dbg-package=digikam-dbg

override_dh_makeshlibs:
	dh_makeshlibs -plibkface2 -V 'libkface2 (>= 1.0~digikam$(DEB_VERSION_UPSTREAM))'
	dh_makeshlibs -plibkgeomap1 -V 'libkgeomap1 (>= 1.0~digikam$(DEB_VERSION_UPSTREAM))'
	dh_makeshlibs -plibmediawiki1 -V 'libmediawiki1 (>= 1.0~digikam$(DEB_VERSION_UPSTREAM))'
	dh_makeshlibs -plibkvkontakte1 -V 'libkvkontakte1 (>= 1.0~digikam$(DEB_VERSION_UPSTREAM))'
	dh_makeshlibs --remaining-packages

# auto tests require user interaction - override
override_dh_auto_test:
